#!/usr/bin/env perl

use utf8;
use AnyEvent;
use AnyEvent::HTTP;
use feature 'say';
use Data::Dumper::Simple;
use common::sense;
use JSON;
use Time::HiRes;

use Mojo::ByteStream 'b';

my $total_request = $ARGV[0];
my $finished;

$AnyEvent::HTTP::MAX_PER_HOST = 1024;


my $url = "http://localhost:3000/msg/send/d4c3d66fd0c38547a3c7a4c6bdc29c36911bc030/theWOWlayer/wtfIdent";
#~ my $pos_json = '{"orien":["78","87"],"move":[["55","55","55","123","34","56"],"77"],"loc":["123","34","56"]}';

my $from = {
	apikey	=> 'apikey2',
	layer	=> 'layer2',
	ident	=> 'ident2',
};
my $epoch = Time::HiRes::gettimeofday;
my $msg = 'lalala科科'.$epoch;
my $pos_json = to_json({ epoch => $epoch, from => $from, msg => $msg });
say Dumper $pos_json;
$pos_json = b($pos_json)->encode('UTF-8');
say Dumper $pos_json;
my $body = "$pos_json";


my $cv = AnyEvent->condvar;

$cv->begin;


for (1..$total_request) {
	#~ say "start: $body";
	$cv->begin;
	http_post $url, $body, sub {
		my ($body, $hdr) = @_;
	
		if ($hdr->{Status} =~ /^2/) {
			$finished++;
			say Dumper($body);
			say $finished if $finished % ($total_request/10) == 0;
		} else {
			print "error, $hdr->{Status} $hdr->{Reason}\n";
		}
		$cv->end;
	};
}





$cv->end;

$cv->recv;
