#!/usr/bin/env perl

use utf8;
use AnyEvent;
use AnyEvent::HTTP;
use feature 'say';
use Data::Dumper::Simple;
use JSON;

my $total_request = $ARGV[0];
my $finished;

$AnyEvent::HTTP::MAX_PER_HOST = 1024;


my $url = "http://localhost:3000/query/nodes";

# sha142424242424242424242424242424242424242  theWOWlayer  wtfIdent
my @subs_list;
push @subs_list, { apikey => 'd4c3d66fd0c38547a3c7a4c6bdc29c36911bc030', layer => 'theWOWlayer', ident => 'wtfIdent' };
#~ push @subs_list, { apikey => 'd4c3d66fd0c38547a3c7a4c6bdc29c36911bc030', layer => 'lllllayer', ident => 'iiiidentttt' };
#~ push @subs_list, { apikey => 'd4c3d66fd0c38547a3c7a4c6bdc29c36911bc030', layer => 'layer2', ident => 'ident2' };
#~ push @subs_list, { apikey => 'd4c3d66fd0c38547a3c7a4c6bdc29c36911bc030', layer => '豬', ident => '狗' };


say Dumper(\@subs_list);

my $post_json = encode_json \@subs_list;
say Dumper($post_json);
my $body = "$post_json";

my $cv = AnyEvent->condvar;

$cv->begin;

#~ my %headers = ('Content-Type' => 'application/x-www-form-urlencoded');

for (1..$total_request) {
	#~ say "start";
	$cv->begin;
	#~ http_post $url, $body, headers => \%headers,  sub {
	http_post $url, $body, sub {
		my ($body, $hdr) = @_;
	
		if ($hdr->{Status} =~ /^2/) {
			$finished++;
			say Dumper($body);
			say $finished if $finished % ($total_request/10) == 0;
		} else {
			print "error, $hdr->{Status} $hdr->{Reason}\n";
		}
		$cv->end;
	};
}


$cv->end;

$cv->recv;
